#include "TObject.h"
#include "TClonesArray.h"
#include "TH1F.h"

class myobject : 
public TObject
{
public:
  myobject() : TObject(), fChild("myobject")
    {fChild.SetOwner(kTRUE);};
  virtual ~myobject() {fChild.Delete();};
protected:
  TClonesArray fChild;
  ClassDef(myobject, 1);
};

ClassImp(myobject);

class child :
public myobject
{
public:
  child() : myobject(), fBool(kFALSE) {};
  ~child() {};
private:
  Bool_t fBool;
  ClassDef(child, 1);
};

ClassImp(child);

class parent :
public myobject
{
public:
  parent() : myobject() {new (fChild[0]) child();};
  ~parent() {};
private:
  ClassDef(parent, 1);
};

ClassImp(parent);

